#!/usr/bin/env python
#
# Change this is font's is small large on your screen
#    
FONT_TICK = "verdana bold 7"
FONT_GARDEN = "verdana 8"
FONT_CONV = "verdana 7"
COLOR_UP = '#0000FF'
COLOR_DN = '#FF0000'
COLOR_PL = '#000000'

CONV_COLORS = {"Void":"grey", "Inactive":"black", "Possible":"#ff66ff","Active":"blue" }
TIME_URL = "http://armeagle.atitd.org/time.php"
STATE_FILENAME = "garden.state"
PROXIES  = None
SHOW_ALWAYS_ACTIVE=False
DEBUG_OUTPUT = False

#TODO: Tree widgets scroll bar change on selection



#
# ==========================================================================
# * DONT CHANGE ANYTHING BELLOW  EXECPT IF YOU ARE KNOW WHAT YOU ARE DOING *
# ==========================================================================
#
VERSION = " v0.2 Beta."
CLOCK_UPDATE = 1200000 # Be nice to the servers

try:
    import gtk, gobject, pango, locale, math, numpy, urllib, pickle, re,json
except:
    print "Required libarries have not been installed"    
    raise SystemExit
import pygtk
if gtk.pygtk_version < (2, 6):
        print "PyGtk 2.6 or later required for this widget"
        raise SystemExit


def _q(cond,true_val,false_val):
    if cond:
        return true_val
    else:
        return false_val
        
#
# The Thistle garden Class
#
class ThistleGarden:
    def init_convos(self):
        LESS = -1
        MORE = 1
        self.convos =[
            (10.0, "Pot", 0),
            (10.0, "Nit", 0),
            (10.0, "Nit",  3.33, "Asc", "Water", MORE, 79.0),
            (10.0, "Car",  5.0,  "Asc", "Oxy",   LESS, 49.0),
            (10.0, "Fol", 20.0,  "Asc", "Sun",   MORE, 69.0),
            (10.0, "Pot",  2.5,  "Bio", "Sun",   LESS, 20.0),
            (10.0, "Asc", 20.0,  "Bio", "Water", LESS, 29.0),
            (10.0, "Pyr", 10.0,  "Bio", "Oxy",   MORE, 89.0),
            (10.0, "Pot",  3.33, "Car", "Oxy",   MORE, 69.0),
            (10.0, "Asc", 10.0,  "Car", "Sun",   MORE, 79.0),
            (10.0, "Thi", 20.0,  "Car", "Water", LESS, 39.0),
            (10.0, "Pot",  2.5,  "Fol", "Sun",   MORE, 69.0),
            (10.0, "Nia", 30.0,  "Fol", "Water", LESS, 59.0),
            (10.0, "Thi", 20.0,  "Fol", "Oxy",   LESS, 49.0),
            (10.0, "Asc", 20.0,  "Nia", "Sun",   LESS, 20.0),
            (10.0, "Pyr",  5.0,  "Nia", "Water", MORE, 69.0),
            (10.0, "Thi", 10.0,  "Nia", "Oxy",   LESS, 39.0),
            (10.0, "Nit",  3.33, "Pyr", "Water", LESS, 39.0),
            (10.0, "Car", 10.0,  "Pyr", "Sun",   MORE, 59.0),
            (10.0, "Fol", 20.0,  "Pyr", "Oxy",   MORE, 79.0),
            (10.0, "Asc", 10.0,  "Thi", "Sun",   LESS, 40.0),
            (10.0, "Car", 20.0,  "Thi", "Oxy",   LESS, 49.0),
            (10.0, "Nia",  5.0,  "Thi", "Water", LESS, 49.0),
            (10.0, "Water", 0),
            (10.0, "Oxy",   0),
        ]
        return
    def convo_get_descr(self,i):
        convo = self.convos[i]
        if convo[2]>0:
            return str(convo[0])+" "+convo[1]+ " -> "+str(convo[2])+" "+convo[3]
        else:
            return "Loose "+str(convo[0])+" "+convo[1]
    def convo_get_condition_txt(self,i):
        STR={-1:"<",1:">"}
        convo = self.convos[i]
        if convo[2]>0:
            return convo[4]+" "+STR[convo[5]]+" "+str(convo[6])
        else:
            return "Always"
    def convo_set_void(self,i,val):
        self.convoState[i]=val
        return
    def convo_is_void(self,i):
        return self.convoState[i]
    def __init__(self):
        self.init_convos()
        self.convoState  = numpy.zeros(len(self.convos),bool)
        self.convo_run = numpy.zeros(len(self.convos),bool)
        
        self.gardenInput = numpy.zeros((41,5),int)
        self.gardenState = numpy.zeros((41,5+7),float)
        self.gardenState_old = numpy.zeros((41,5+7),float)
        
        self.gardenInput[0,2]=5
        self.gardenInput[0,3]=5
        self.gardenInput[10,3]=5 # Add 10 Oxy
        self.gardenInput[20,3]=5 # Add 10 Oxy
        self.gardenInput[29,0]=5 # Add 5 Nit
        self.gardenInput[29,3]=5 # Add 5 Nit
        
        #for i in range(len(self.convos)):
        #    print self.convo_get_descr(i),"\t",self.convo_get_condition_txt(i)
        #exit()
        return
    def set_input(self,tick,input,value):
        inputs=["NIT","POT","WATER","OXY","SUN"]
        col=inputs.index(input.upper())
        self.gardenInput[tick,col]=value
        return
    def get_input(self,tick):
        return self.gardenState[tick]

    def _state_idx(self,text):
        inputs=["NIT","POT","WATER","OXY","SUN","ASC",'BIO','CAR','FOL','NIA','PYR','THI']
        return inputs.index(text.upper())
    
    def get_thistle(self):
        string ="ABCFNPT"
        ret = ""
        state = self.gardenState_old[40,5:12]
        for i in range(len(string)) :
            ret += string[i]
            if state[i] < 22:
                ret += "-"
            else:
                if  state[i] >= 80:
                    ret += "+"
                else:
                    ret += "~"
        return ret
    
    def run(self):
        TICKS = 41
        SUN = 4
        self.tick_actions=[]    # Store what actions is happend at each list
        self.tick_conv_state=[] # Store comvo state for each convo
        self.convo_run = numpy.zeros(len(self.convos),bool)    
        for tick in range(TICKS):
            # Add input idegriends
            if tick == 0:
                # Start with 50 of each
                begin_state = map(lambda x: min(99.00,x), numpy.ones(5,float)*50 + self.gardenInput[tick]*20)
                begin_state.extend(numpy.zeros(7).tolist())
                begin_state[SUN] = self.gardenInput[0,SUN]
            else:
                begin_state = map(lambda x: min(99.00,x), self.gardenState[tick-1,0:5] + self.gardenInput[tick]*20 )
                begin_state.extend(self.gardenState[tick-1,5:12].tolist())
                # Calculate Sun
                if self.gardenInput[tick,SUN] != 0:
                    begin_state[SUN] = self.gardenInput[tick,SUN]
                else:
                    begin_state[SUN] = self.gardenState[tick-1,SUN]
            self.gardenState_old[tick]=begin_state
            
            tick_actions=[]
            tick_convo_state=[]
            for i in range(len(self.convos)):
                C = self.convos[i]
                # Check 1: Convo is not set to void
                convo_state="Void"
                if not self.convo_is_void(i):
                    convo_state="Inactive"
                    # Check 2: Is conversion Active?
                    if C[2]>0: # There is not an always conversion
                        state_value = begin_state[self._state_idx(C[4])]
                        active = ((state_value-C[6])*C[5] >0)                        
                        #print "Check ", self.convo_get_condition_txt(i), "\t\t(", state_value, "?",C[6], "):", active
                    else:
                        active = True
                    if active:
                        convo_state="Possible"
                        # The conversion is not a void, and it is active at this step
                        # Check 3: Check if there is something to convert
                        take = begin_state[self._state_idx(C[1])]
                        if take > 0:
                            convo_state="Active"
                            take_out = min(take,C[0])
                            begin_state[self._state_idx(C[1])] -= take_out
                            calculations = C[1]+"="+ "%2.2f" % begin_state[self._state_idx(C[1])]
                            self.convo_run[i] = True
                            if C[2]>0:
                                new_vit  = C[2]/C[0] * take_out
                                begin_state[self._state_idx(C[3])] = min(99.99, begin_state[self._state_idx(C[3])]+new_vit)
                                calculations += ", "+ C[3]+"="+ "%2.2f" % begin_state[self._state_idx(C[3])]
                                action = ["- "+str(take_out)+" "+C[1], "+ "+str(new_vit)+" "+C[3], self.convo_get_condition_txt(i), calculations,i]
                            else:  
                                action = ["- "+str(take_out)+" "+C[1]," "," ",calculations,i]
                            tick_actions.append(action)
                tick_convo_state.append(convo_state)
            # End for for convos
            self.gardenState[tick] = begin_state
            self.tick_actions.append(tick_actions)
            self.tick_conv_state.append(tick_convo_state)
        # END FOR STEPS
#### End ThistleGarden class            

class ThistleGardenUI:
    def __init__(self):
        # Create an empty Garden
        self.childs = []   # This will hold MDI's
        garden = ThistleGarden()
        glbl = gtk.Label("new_garden")
        self.childs.append([glbl,garden])
        self.garden= garden
        self.MDIlabel = glbl
        
        garden2 = ThistleGarden()
        garden2.gardenInput[0,4]=33
        glbl2 = gtk.Label("new_garden")
        self.childs.append([glbl2,garden2])
         
        self.current_tick = -1
        self.states = ['Nit','Pot','Water','Oxy','Sun','Asc','Bio','Car','Fol','Nia','Pyr','Thi']
        self.show_states = self.states[:]

        # Create the main Window
        window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        window.set_title("Talos Thiste Garden simulator"+ VERSION)
        window.connect("delete_event", self.delete_cb)
        window.connect("destroy", self.destroy_cb)
        window.set_border_width(0)
        window.set_role("thistle-sim")
        window.set_size_request(-1,580)
        self.window = window
        
        # Split in function to easily manage the code
        self.gui_InputTree()
        self.gui_StateTree()
        self.gui_VitaminsTree()
        self.gui_conversionsTree()
        self.gui_recipiesTree()
        self.gui_stepTree()
        self.gui_Toolbox()
        
        # Create the trees
        tv0 = addScrollBarToTreeView(self.input_view)
        tv1 = self.packHeaderIntoTreeView(tv0, "<i>Inputs</i>")
        tv2 = self.packHeaderIntoTreeView(self.state_view, "<i>Garden State</i>")
        tv3 = self.packHeaderIntoTreeView(self.vitamins_view, "<i>Garden Vitamins</i>")
        self.state_view.set_vadjustment(self.input_view.get_vadjustment())
        self.vitamins_view.set_vadjustment(self.input_view.get_vadjustment())

        # Make a box and pack the trees
        gBox = gtk.HBox()
        gBox.pack_start(tv1,False,False,6)
        gBox.pack_start(tv2,False,False,6)
        gBox.pack_start(tv3,False,False,6)
        
        gBox.show()
                
        # The main Area box
        appBox = gtk.HBox()
        appBox.pack_start(gBox,False,True,0)
        appBox.pack_start(self.toolbox,False,False,0)
        
        # The MDI
        notebook = gtk.Notebook()
        notebook.set_tab_pos(gtk.POS_TOP)
        notebook.set_properties(show_border=False)
        notebook.show()
        self.notebook = notebook
        
        # The Status Bar
        self.status_bar = gtk.Statusbar()
        self.status_cost = self.status_bar.get_context_id("cost")
        self.status_cost_txt = self.status_bar.push(self.status_cost, "EMPTY")
        
        # The Window Box
        window_box = gtk.VBox()
        window_box.pack_start(notebook,False,True)
        window_box.pack_start(appBox,True,True)
        window_box.pack_end(self.status_bar,False,False)
        window.add(window_box)
        
        # Finally show the Window
        self.firstrun()
        self.update()
        window.show_all()
        notebook.connect("switch-page",self.change_mdi_cb)
        return

    def firstrun(self):
        # Load previous garden state
        try:
            LOAD_STATE = True
            save_state = pickle.load(open(STATE_FILENAME))
        except:
            LOAD_STATE = False
        if LOAD_STATE:
            recipies = save_state[2]
            for j in range( len(recipies)):
                self.recipie_model.append(recipies[j]+[True])
                    
        # Init MDI
        for row in self.childs:
            self.notebook.insert_page(gtk.VBox(),row[0])
            self.garden = row[1]
            if LOAD_STATE:
                voids = save_state[0]
                for j in range( len(voids)):
                    row[1].convo_set_void(voids[j],True)
            row[1].run()
            row[0].set_text(row[1].get_thistle())
        self.garden = self.childs[0][1]

            
        #self.garden.run()
        for i in range(41):
            self.input_model.append([i] + self.garden.gardenInput[i].tolist()+[False])
            self.state_model.append([0.0]*5 +["black"]*5)
            self.vitamins_model.append([0.0]*7+["black"]*7)
        for j in range( len(self.garden.convos)):
            if SHOW_ALWAYS_ACTIVE :
                visibility = True
            else :
                visibility = self.garden.convos[j][2] > 0
            self.conversions_model.append((j,self.garden.convo_get_descr(j),
                                           self.garden.convo_get_condition_txt(j),
                                           "","black",self.garden.convo_is_void(j)
                                           ,visibility,gtk.STOCK_APPLY,False,None))
        # Select Row 0 to force step show
        self.current_tick = -1
        self.input_view.get_selection().select_path(0)
        self.view_selection_change_cb(self.input_view.get_selection())


    def update(self):
        # Update Garden
        self.garden.run()
        self.MDIlabel.set_text(self.garden.get_thistle())
        itemColors = [COLOR_DN,COLOR_PL,COLOR_UP]
        old_state = self.garden.gardenState_old[0,0:5]
        old_vits  = self.garden.gardenState_old[0,5:14]
        for i in range(41):
            # The tick numbers
            #lst = list(self.input_model[i])
            #lst[1:6] = self.garden.gardenInput[i].tolist()
            #self.input_model[i] = lst

            dif = numpy.sign(old_state - self.garden.gardenState_old[i,0:5])+1
            self.state_model[i]=self.garden.gardenState_old[i,0:5].tolist() + map(lambda x: itemColors[int(x)], dif)
            dif = -1*numpy.sign(old_vits - self.garden.gardenState_old[i,5:14])+1
            self.vitamins_model[i]=self.garden.gardenState_old[i,5:14].tolist() + map(lambda x: itemColors[int(x)], dif)
            old_state = self.garden.gardenState_old[i,0:5]
            old_vits  = self.garden.gardenState_old[i,5:14]
        # Update voids
        RunIcons = {True:gtk.STOCK_YES, False: None}
        for i in range(len(self.garden.convoState)):
            self.conversions_model[i][5]= self.garden.convo_is_void(i)
            self.conversions_model[i][9]= RunIcons[ self.garden.convo_run[i] ]
            
        # Update Recipies
        thistle = self.garden.get_thistle()
        for i in range(len(self.recipie_model)):
            recipie = self.recipie_model[i][0]
            # Remove markup dirty method
            p = re.compile(r'<.*?>')
            recipie = p.sub('', recipie)
            recipie = recipie.strip()
            markup=""
            for j in range (int(len(recipie)/2)):
                if thistle.find(recipie[2*j:2*j+2]) >= 0:
                    markup += "<b>"+ recipie[2*j:2*j+2]+"</b>"
                else:
                    markup += recipie[2*j:2*j+2]
            self.recipie_model[i][0]=" "+markup # A bug hides 1 bold entry

        # Update the status bar
        costs = numpy.sum(self.garden.gardenInput,0)
        cost_str = " Dung: "+ str(costs[0])+", Saltpeter: "+str(costs[1])+", Water:"+str(costs[2])+", Oxy:"+str(costs[3])
        self.status_bar.remove(self.status_cost,self.status_cost_txt)
        self.status_cost_txt = self.status_bar.push(self.status_cost,cost_str)
        
        #sel=self.input_view.get_selection()
        #(model,iter) = sel.get_selected()
        #sel.select_iter(iter)
        self.current_tick = -1
        self.input_view.get_selection().emit("changed")
        return

    #
    # GUI CONSTRUCTION HELPERS
    #
    def gui_InputTree(self):
        #It have 1 exta column with the tick Number, one extra to hold stock item, one extra for visibility
        columns = [gobject.TYPE_INT]+[gobject.TYPE_STRING]*5+[gobject.TYPE_BOOLEAN]
        input_model = gtk.ListStore(*columns)
        input_view  = gtk.TreeView(input_model)
        input_view.set_rules_hint(True)
        input_view.set_properties(enable_grid_lines=True)
        
        tickTextRenderer = gtk.CellRendererText()
        pixbufRdr = gtk.CellRendererPixbuf()
        pixbufRdr.set_properties(stock_id=gtk.STOCK_MEDIA_PLAY)
        tickTextRenderer.set_properties(alignment=pango.ALIGN_RIGHT, xalign=1.0, font_desc=pango.FontDescription(FONT_TICK))
        tick_col = gtk.TreeViewColumn('Tick')
        tick_col.pack_start(pixbufRdr,False)
        tick_col.pack_start(tickTextRenderer,True)
        tick_col.set_attributes(pixbufRdr,visible=6)
        tick_col.set_attributes(tickTextRenderer,text=0)
        input_view.append_column(tick_col)
        #input_view.insert_column_with_attributes(-1,"Tick",tickTextRenderer,text=0)
        
        labels = ["Nit","Pot","Water","Oxy"]
        adj = gtk.Adjustment(value=0, lower=0, upper=5, step_incr=1)
        for i in range(len(labels)):
            spinTextRenderer = gtk.CellRendererSpin()
            spinTextRenderer.set_properties(editable=True,adjustment=adj,digits=0)
            spinTextRenderer.set_properties(alignment=pango.ALIGN_RIGHT, xalign=1.0, font_desc=pango.FontDescription(FONT_GARDEN))
            spinTextRenderer.connect("edited", self.edit_inputcell_cb,i)
            col = input_view.insert_column_with_attributes(-1,labels[i],spinTextRenderer,text=i+1)
            col.set_cell_data_func(spinTextRenderer, self.render_input)
        
        spinTextRenderer = gtk.CellRendererSpin()
        adj2 = gtk.Adjustment(value=0, lower=0, upper=99, step_incr=33)
        spinTextRenderer.set_properties(editable=True,adjustment=adj2,digits=0)
        spinTextRenderer.set_properties(alignment=pango.ALIGN_RIGHT, xalign=1.0, font_desc=pango.FontDescription(FONT_GARDEN))
        spinTextRenderer.connect("edited", self.edit_inputcell_cb,4)
        col = input_view.insert_column_with_attributes(-1,"Sun",spinTextRenderer,text=5)
        col.set_cell_data_func(spinTextRenderer, self.render_input)
        
        input_view.get_selection().connect('changed',self.view_selection_change_cb)
        input_view.connect('scroll-event',self.view_scroll_cb)
        
        input_view.show()
        self.input_model = input_model
        self.input_view = input_view   
        return
    
    def gui_StateTree(self):
        # 5 Floats for the state and 5 Strings for colors
        columns = [gobject.TYPE_FLOAT]*5 +[gobject.TYPE_STRING]*5
        state_model = gtk.ListStore(*columns)
        state_view = gtk.TreeView(state_model)
        state_view.set_rules_hint(True)
        state_view.set_properties(enable_grid_lines=True,enable_search=False)

        stateTextRenderer = gtk.CellRendererText()
        stateTextRenderer.set_properties(alignment=pango.ALIGN_RIGHT, xalign=1.0)
        stateTextRenderer.set_properties(font_desc=pango.FontDescription(FONT_GARDEN), foreground_set=True)
        Headers=["Nit","Pot","H20","O2","Sun"]
        for i in range(5):
            col = state_view.insert_column_with_attributes(-1,Headers[i],stateTextRenderer,text=i,foreground=i+5)
            col.set_cell_data_func(stateTextRenderer, self.render_state)
        state_view.get_selection().connect('changed',self.view_selection_change_cb)
        state_view.connect('scroll-event',self.view_scroll_cb)
        state_view.show_all()
        
        self.state_model = state_model
        self.state_view = state_view
        return
    
    def gui_VitaminsTree(self):
        # 7 Vitamins + 7 Colors
        columns = [gobject.TYPE_STRING]*7 +[gobject.TYPE_STRING]*7
        vitamins_model = gtk.ListStore(*columns)
        vitamins_view = gtk.TreeView(vitamins_model)
        vitamins_view.set_rules_hint(True)
        vitamins_view.set_properties(enable_grid_lines=True,enable_search=False)
        
        HeadersVit   = ["Asc","Bio","Car","Fol","Nia","Pyr","Thi"]
        VitsTextRenderer = gtk.CellRendererText()
        VitsTextRenderer.set_properties(font_desc=pango.FontDescription(FONT_GARDEN), foreground_set=True, alignment=pango.ALIGN_RIGHT, xalign=1.0)
        for i in range(7):
            col = vitamins_view.insert_column_with_attributes(-1,HeadersVit[i],VitsTextRenderer,markup=i,foreground=i+7)
            col.set_cell_data_func(VitsTextRenderer, self.render_vits)
        vitamins_view.get_selection().connect('changed',self.view_selection_change_cb)
        vitamins_view.connect('scroll-event',self.view_scroll_cb)
        vitamins_view.show_all()
        self.vitamins_model = vitamins_model
        self.vitamins_view  = vitamins_view
        return
    
    def gui_stepTree(self):
        columns = [gobject.TYPE_STRING]*5
        step_model = gtk.ListStore(*columns)
        step_view  = gtk.TreeView(step_model)
        step_view.set_properties(enable_search=False,reorderable=True,headers_clickable=True)
        step_view.set_rules_hint(True)
        
        Headers = ["Take","Make","Reason","Calculations","id"]
        renderer = gtk.CellRendererText()
        renderer.set_properties(font_desc=pango.FontDescription(FONT_GARDEN),foreground_set=True)
        for i in range(5):
            step_view.insert_column_with_attributes(-1,Headers[i],renderer,text=i)
        step_view.show()
        step_view.connect('scroll-event',self.view_scroll_cb)
        step_view.get_selection().connect('changed',self.step_selection_change_cb)
        self.step_model = step_model
        self.step_view = step_view
        
    def gui_recipiesTree(self):
        # 2 Text columns + editable Flag
        columns = [gobject.TYPE_STRING]*2+[gobject.TYPE_BOOLEAN]
        recipie_model = gtk.ListStore(*columns)
        recipie_view  = gtk.TreeView(recipie_model)
        recipie_view.set_properties(fixed_height_mode=False)
        recipie_view.set_rules_hint(True)
        
        Headers = ["Request","Notes"]
        #TODO: Editable
        renderer = gtk.CellRendererText()
        # Thistle
        renderer = gtk.CellRendererText()
        renderer.set_properties(editable=True)
        renderer.set_data("column", 0)
        renderer.set_properties(font_desc=pango.FontDescription(FONT_GARDEN))
        renderer.connect("edited", self.recipie_edited_cb, recipie_model)
        recipie_view.insert_column_with_attributes(-1,Headers[0],renderer,markup=0,editable=2)

        renderer2 = gtk.CellRendererText()
        renderer2.set_properties(editable=True,ellipsize=pango.ELLIPSIZE_END,wrap_width=50,wrap_mode=pango.WRAP_WORD)
        renderer2.set_data("column", 1)
        renderer2.set_properties(font_desc=pango.FontDescription(FONT_GARDEN))
        renderer2.connect("edited", self.recipie_edited_cb, recipie_model)
        recipie_view.insert_column_with_attributes(-1,Headers[1],renderer2,markup=1,editable=2)
        
        recipie_view.show()
        #Events
        recipie_view.connect('scroll-event',self.view_scroll_cb)
        recipie_view.connect("button_press_event", self.recipies_pop_up_cd)
        
        self.recipie_model = recipie_model
        self.recipie_view = recipie_view
        
    
    def gui_conversionsTree(self):
        # Ad id, convesrion,when,state,color,void (bool), convesrion_is_always_active (bool) , The tick and the visibiliy
        columns = [gobject.TYPE_INT]+[gobject.TYPE_STRING]*4+[gobject.TYPE_BOOLEAN]*2 + [gobject.TYPE_STRING]+[gobject.TYPE_BOOLEAN]+[gobject.TYPE_STRING]
        conversions_model = gtk.ListStore(*columns)
        treemodelfilter = conversions_model.filter_new()
        
        conversions_view = gtk.TreeView(treemodelfilter)
        conversions_view.set_rules_hint(True)
        
        Headers = ["ID","Conversion","Conditions","Status","V","Run"]
        
        
        pixbufRdr = gtk.CellRendererPixbuf()
        conversionsTextRenderer = gtk.CellRendererText()
        conversionsTextRenderer.set_properties(font_desc=pango.FontDescription(FONT_CONV),foreground_set=True, xpad=4)
        
        conversions_view.insert_column_with_attributes(-1,Headers[0],conversionsTextRenderer,text=0,foreground=4)
        
        toogleRenderer = gtk.CellRendererToggle()
        toogleRenderer.set_property('activatable', True)
        toogleRenderer.connect( 'toggled', self.set_void_cb, )
        conversions_view.insert_column_with_attributes(-1,Headers[4],toogleRenderer,active=5)
        
        col1 = gtk.TreeViewColumn(Headers[1])
        col1.pack_start(conversionsTextRenderer, True)
        col1.set_properties(resizable=True, expand=True)
        col1.set_attributes(conversionsTextRenderer, text=1)
        conversions_view.append_column(col1)
        
        col = gtk.TreeViewColumn(Headers[3])
        col.pack_start(conversionsTextRenderer,True)
        col.pack_start(pixbufRdr,False)
        col.set_attributes(pixbufRdr,stock_id=7,visible=8)
        col.set_properties(spacing=6)
        col.set_attributes(conversionsTextRenderer,text=3)
        conversions_view.append_column(col)
        
        conversions_view.insert_column_with_attributes(-1,Headers[2],conversionsTextRenderer,text=2,foreground=4)                
        conversions_view.insert_column_with_attributes(-1,Headers[5],pixbufRdr, stock_id=9 )

        
        treemodelfilter.set_visible_column(6)
        
        conversions_view.show_all()
        conversions_view.connect('scroll-event',self.view_scroll_cb)
        
        
        voidsfilter = conversions_model.filter_new()
        voidsfilter.set_visible_column(5)
        voids_view = gtk.TreeView(voidsfilter)
        renderer = gtk.CellRendererText()
        renderer.set_properties(font_desc=pango.FontDescription(FONT_GARDEN),foreground_set=True, xpad=4)
        voids_view.insert_column_with_attributes(-1,Headers[0],renderer,text=0)
        voids_view.insert_column_with_attributes(-1,Headers[1],renderer,text=1)
        voids_view.insert_column_with_attributes(-1,Headers[2],renderer,text=2)
        voids_view.show_all()
        
        self.void_view = voids_view
        self.conversions_model = conversions_model
        self.conversions_view = conversions_view
        self.conversions_filter = treemodelfilter 
        return
    
    def gui_Toolbox(self):
        # Create a Handler for the ToolBox
        handler = gtk.HandleBox()
        handler.set_properties(handle_position=gtk.POS_TOP,shadow_type=gtk.SHADOW_ETCHED_OUT,snap_edge=gtk.POS_LEFT,snap_edge_set=True)
        handler.connect("child-attached",self.toolbox_attached_cb)
        handler.connect("child-detached",self.toolbox_dettached_cb)

        handler_box = gtk.VBox()
        handler_box.set_size_request(-1,460)
        handler.add(handler_box)
       
        handler_header = gtk.Label()
        handler_header.set_use_markup(True)
        handler_header.set_markup("<b>Toolbox</b>")
        
        handler_box.pack_start(handler_header,False,False)
        toolbox = gtk.VBox()
        toolbox.set_border_width(6)
        handler_box.pack_start(toolbox,True,True)
        pan1 = gtk.VPaned()
        pan1.set_position(180)
        
        notebookT = gtk.Notebook()
        notebookT.set_tab_pos(gtk.POS_BOTTOM)
        
        nt1 = addScrollBarToTreeView(self.conversions_view)
        nt2 = addScrollBarToTreeView(self.recipie_view)
        notebookT.append_page(nt1, gtk.Label("Conversions"))
        notebookT.append_page(self.void_view,gtk.Label("Voids"))
        notebookT.append_page(nt2, gtk.Label("Requests"))
        notebookT.set_current_page(2)

        pan_frame1 = gtk.Frame()
        pan_frame1.set_shadow_type(gtk.SHADOW_IN)
        pan_frame1.add(notebookT)
        pan1.add1(pan_frame1)
        
        pan1_box=gtk.VBox()
        self.label_tick = gtk.Label("Conversions at tick 0")
        pan1_box.pack_start(self.label_tick,False,False,0)
        scrolledTree = addScrollBarToTreeView(self.step_view)
        pan1_box.pack_start(scrolledTree,True,True,0)
        pan_frame2 = gtk.Frame()
        pan_frame2.set_shadow_type(gtk.SHADOW_IN)
        pan_frame2.add(pan1_box)
        pan1.add2(pan_frame2)
        
        toolbox.pack_start(pan1,True,True)
        self.time_widget = gtk.Label()
        self.get_atitd_time()
        self.time_widget.set_padding(20,10)
        toolbox.pack_end(self.time_widget,False,False)
        toolbox.pack_end(gtk.HSeparator(),False,False)
        
        handler.show_all()
        self.toolbox = handler
    
    #
    # GUI CONSTRUCTION UTILITIS
    #
    def packHeaderIntoTreeView(self,widget,label_text):
        box = gtk.VBox(False,0)
        label = gtk.Label()
        label.set_use_markup(True)
        label.set_markup(label_text)
        box.pack_start(label,False,True,0)
        box.pack_start(widget,True,True,0)
        return box 
    
    #
    # THE CALLBACK FUNCTIONS
    #
    def main(self):
        gtk.main()
    
    def delete_cb(self,widget, data=None):
        # Write state data
        state =[]
        voids = []
        for i in range(len(self.garden.convos)):
            if self.garden.convo_is_void(i):
                voids.append(i)
        state.append(voids)
        
        # TODO Sun
        state.append([True])  # Sun Note
        
        recipies = []
        for i in range(len(self.recipie_model)):
            p = re.compile(r'<.*?>')
            recipie = self.recipie_model[i][0]
            recipie = p.sub('', recipie)
            recipie = recipie.strip()
            recipies.append([recipie,self.recipie_model[i][1]])
        state.append(recipies)
        
        try:
            pickle.dump(state,open( STATE_FILENAME, "w"))
        except:
            print " Problem saving state"
            pass
        return False
    
    def destroy_cb(self, widget, data=None):
        gtk.main_quit()
    
    # When user edit an imput using the table view spinner
    def edit_inputcell_cb(self,cell,path,new_text,column):
        adj = cell.get_property("adjustment")
        upper = adj.get_property("upper")
        lower =  adj.get_property("lower")
        value = max(min(int(locale.atof(new_text)),upper),lower)
        self.input_model[path][column+1] = value
        self.garden.gardenInput[int(path), column] = value 
        self.update()
        return False
    
    # Execute when user clicks on a tree view (scroll bar handling)
    def view_scroll_cb(self,widget, event):
        model, paths = widget.get_selection().get_selected_rows()
        if paths:
            path = paths[0][0]
            if event.direction == gtk.gdk.SCROLL_DOWN:
                widget.get_selection().select_path(path+1)
            else:
                if path >= 1:
                    widget.get_selection().select_path(path-1)
            widget.scroll_to_cell(path, use_align=True, row_align=0.8)
        return False

    # Executed when the input cell selectin change
    def step_selection_change_cb(self,selection):
        #TODO: Synchonize with scroll bar
        model, paths = selection.get_selected_rows()
        if paths:
            path = paths[0][0]
            id = model[path][4] # id if the model path
            filter = self.conversions_filter
            # convert math to filter path
            view_path =  filter.convert_child_path_to_path(id)  
            if view_path :
                self.conversions_view.get_selection().select_path(view_path)

    
    # Executed when the input cell selectin change
    def view_selection_change_cb(self,selection):
        model, paths = selection.get_selected_rows()
        if paths:
            # Step 1 Synchoronize selections
            path = paths[0][0]
            self.input_view.get_selection().select_path(path)
            self.state_view.get_selection().select_path(path)
            self.vitamins_view.get_selection().select_path(path)
            #self.input_view.set_cursor(path)
            if self.current_tick != int(path):
                # Step 2: Update Conversion Status
                Stock = {"Active": gtk.STOCK_APPLY, "Inactive": None, "Possible": gtk.STOCK_INFO, "Void": None}
                for i in range(len(self.garden.convos)):
                    self.conversions_model[i][3]=self.garden.tick_conv_state[int(path)][i]
                    self.conversions_model[i][4]=CONV_COLORS[self.conversions_model[i][3]]
                    self.conversions_model[i][8] = not self.conversions_model[i][5] 
                    self.conversions_model[i][7] = Stock[self.conversions_model[i][3]]
                # Step 3: Upadte Steps
                # print self.garden.tick_actions[int(path)]
                self.step_model.clear()
                for i in range(len(self.garden.tick_actions[int(path)])):
                    self.step_model.append(self.garden.tick_actions[int(path)][i])
                self.label_tick.set_text("Conversions at tick "+str(path))
            # Update Visiblity of Tick mark
            for row in self.input_model:
                row[6] = False
            self.input_model[path][6] = True
            # Store current tick
            self.current_tick = int(path)
        return False
    
    def toolbox_attached_cb(self,widget,data):
        x,y,w,h = self.window.get_allocation()
        X,Y,W,H = widget.get_allocation()
        self.window.resize(w+W,h)
        return False
    
    def toolbox_dettached_cb(self,widget,from_widget):
        x,y,w,h = self.window.get_allocation()
        X,Y,W,H = widget.get_allocation()
        self.window.resize(w-W,h)
        return False
    def set_void_cb(self, cell, path):
        # get toggled iter
        filter =self.conversions_view.get_model()
        model_path =  filter.convert_path_to_child_path(path)[0]
        self.garden.convo_set_void(model_path, not self.garden.convo_is_void(model_path))
        self.update()
        return True
    
    # Pop up for recipies list
    def recipies_pop_up_cd(self,widget,event):
        if event.button == 3 and event.type == gtk.gdk.BUTTON_PRESS :
            # see if there is a selected order item
            selection = self.recipie_view.get_selection()
            (model,node) = selection.get_selected()
            active = (node != None)
            menu = gtk.Menu()
            for stock_id,callback,sensitivity in [
                                                  (gtk.STOCK_ADD, self.recipies_add_cb, True),
                                                  (gtk.STOCK_REMOVE, self.recipies_del_cb, active)]:
                item = gtk.ImageMenuItem(stock_id)
                item.connect("activate",callback)
                item.set_sensitive(sensitivity)
                item.show()
                menu.append(item)
                menu.popup(None,None,None,event.button,event.time)
            return True
        else :
            return False

    def recipies_add_cb(self,widget):
        self.recipie_model.append(("A-B-C-F-N-P-T-","",True))
        return True

    def recipies_del_cb(self,widget):
        selection = self.recipie_view.get_selection()
        (model,node) = selection.get_selected()
        if node:
            model.remove(node)
        return True

    def recipie_edited_cb(self,cell, path_string, new_text, model):
        iter = model.get_iter_from_string(path_string)
        column = cell.get_data("column")
        model.set(iter, column, new_text)
        self.update()
        return True
    
    def change_mdi_cb(self,notebook, page, page_num):
        garden = self.childs[page_num][1]
        label = self.childs[page_num][0]
        self.garden = garden
        for i in range(41):
            # The tick numbers
            lst = list(self.input_model[i])
            lst[1:6] = self.garden.gardenInput[i].tolist()
            self.input_model[i] = lst

        garden.run()
        label.set_text(garden.get_thistle())
        self.update()

    #
    # The Renderes of text in Tree Views
    #
    def render_input(self, column, cell, model, iter):
        origstr = cell.get_property('text')
        number = locale.atof(origstr)
        if number == 0 :
            sizestr = ""
        else:
            sizestr = origstr 
        cell.set_property('text', sizestr)
        return
    def render_state(self, column, cell, model, iter):
        origstr = cell.get_property('text')
        number = locale.atof(origstr)
        if number == 0 :
            sizestr = "-"
        else:
            sizestr = _q(DEBUG_OUTPUT, "%2.2f" % number , "%2d" % number)
        cell.set_property('text', sizestr) 
        return
    def render_vits(self, column, cell, model, iter):
        origstr = cell.get_property('text')
        #number = math.floor(locale.atof(origstr))
        #number = locale.atof(origstr)
        number = float(origstr)
        if number == 0 :
            sizestr = "-"
            markup="-"
        else:
            #sizestr = "%2.2f" % number
            sizestr = _q(DEBUG_OUTPUT, "%2.3f" % number , "%d" % math.floor(number))
            if number < 22:
                markup = sizestr
            else :
                if number >= 80:
                    markup = " <b><u>"+sizestr+"</u></b>"
                else :
                    markup = " <b>"+sizestr+"</b>"
        #cell.set_property('text', markup)
        cell.set_property('markup', markup)
        return
    
    #
    # Misc functions
    #
    def get_atitd_time(self):
        try:
            filehandle = urllib.urlopen(TIME_URL, proxies=PROXIES)
            self.atitd_time = filehandle.readline()
            filehandle.close()
        except:
            self.atitd_time = "No network"
        self.time_widget.set_text(self.atitd_time)
        gobject.timeout_add(CLOCK_UPDATE,self.get_atitd_time)
        
#
# Some Helper functions
#

#
# Pack a treeView inside an expander. Return a Box
#
def packWidgetIntoExpander(widget,label,is_expanded,size=160,border=5):
    expander = gtk.Expander()
    expander.set_use_markup(True)
    expander.set_label(label)
    expander.set_border_width(border)
    expander.set_expanded(is_expanded)
    widget.set_size_request(-1,size)
    expander.add(widget)
    expander.connect("map",packWidgetIntoExpanderMapHandler,widget)
    return expander
def packWidgetIntoExpanderMapHandler(expander,contents):
    t,b,w,h = contents.get_allocation()
    expander.set_size_request(w,-1)
    return True

#
#  Adds a vertical scrollbar to a tree view, returning an hbox holding them both 
#
def addScrollBarToTreeView(treeView) :
    pAdj = treeView.get_vadjustment()
    vScrollBar = gtk.VScrollbar(pAdj)
    hBox = gtk.HBox(False)
    # First insert the tree view
    hBox.pack_end(treeView,True,True,0)
    treeView.set_size_request(-1,10)
    treeView.show()
    # Then, packed up against its right side, add in a vbox containing a
    # box for padding at the top and the scrollbar below that 
    vBox = gtk.VBox(False, 0)
    hBox.pack_start(vBox,False,False,0)
    vBox.show()
    padBox = gtk.HBox(False,0)
    btn = gtk.Button()
    padBox.pack_start(btn)
    vBox.pack_start(padBox,False,False,0)
    padBox.show()
    vBox.pack_start(vScrollBar,True,True,0)
    vScrollBar.show()
    treeView.connect("map",treeViewScrollBarMapHandler, padBox, hBox)
    # TODO Action to move at top/bottom at button press
    return hBox;
# Helper function to put scroll bar in place
def treeViewScrollBarMapHandler(treeView, padBox,container):
    x,y = treeView.convert_bin_window_to_widget_coords(0,0)
    padBox.set_size_request(-1,y)
    return True
            
if __name__ == "__main__" :
    app = ThistleGardenUI()
    app.main()    
    
